#include "mcc_generated_files/mcc.h"
#include "mcc_generated_files/examples/i2c1_master_example.h"

#define TIME_OFF -1         //^C}[gpȂꍇ
#define TIME_UP 0           //^CAbv
#define DI_NUM 4            //DItB^̃TvO
#define	CNT_INIT_MAX 10     //10ms~10 = 100ms
#define TIME_FILTER_MAX 1
#define LCD_TIM_MAX 10
#define EEP_MAX 200

#define SLAVE_ADRS 0x3E
#define LINE1_ADRS 0x40
#define LINE2_TOP (0x40 +0x80)
#define FUNC1_SET 0x38
#define FUNC2_SET 0x39
#define INT_OSC 0x14
#define CONST_SET 0x77 //0x73
#define PWR_ICON_SET 0x54 //0x56
#define FOLLOWER_SET 0x6C
#define CLR_DISP 0x01
#define DISP_ONOFF_SET 0x0C

#define EEP_ADRS_M  0x00
#define EEP_ADRS_C  0x80

typedef struct{
	uint8_t    wp;
	uint8_t    buf[ DI_NUM ];
    uint8_t    di;
}FILT_DATA;

uint8_t CntInit;	//̂ݎgp
FILT_DATA DiData;
int8_t timfilter;   //DItB^N
int16_t timlcd;
int16_t timbtnwait = TIME_OFF;
uint8_t btncnt;
uint8_t btncntInit;
bool btn1hold;
uint8_t initmoji[2][16] ={"PIC16F1827-EEP","         Ver1.00"};

void mainTimer(void);
void mainApp(void);
void DiFilterInit(void);
void DiFilter(void);
void LcdInit(void);
void DspLine2Top(void);
void DspClear(void);
void DispSet(void);
void EepRead(void);

/* Main application */
void main(void)
{
    SYSTEM_Initialize();
    TMR0_SetInterruptHandler(mainTimer);
    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();
    
    EepRead();  //EEP̃f[^ǂݏo
    DiFilterInit();
    LcdInit();

    while (1)
    {
        mainApp();
        DiFilter();        
    }
}
/* CAv */
void mainApp(void){
    
    if( DiData.di == 0){

        if( btn1hold == false ){
            btn1hold = true;
            if( timbtnwait == TIME_OFF ){
                timbtnwait = EEP_MAX;
            }
            if(++btncnt >= 100 ){
                btncnt = 0;
            }
        }
    }
    else{
        timbtnwait = TIME_OFF;
        btn1hold = false;
    }    
 
    if( timlcd == TIME_UP ){
        timlcd = LCD_TIM_MAX;
        DispSet(); //LCD\Zbg
    }
    if( timbtnwait == TIME_UP){
        timbtnwait = TIME_OFF;
        
        if(btncnt != 0x00){
            --btncnt;
        }
        
        if( btncnt != btncntInit){
            DATAEE_WriteByte(EEP_ADRS_M, btncnt); //EEP
            DATAEE_WriteByte(EEP_ADRS_C, btncnt); //EEP
            btncntInit = btncnt;
        }
    }
}
/* ^C}Ǘ֐ */
void mainTimer(void){
            
    if( timlcd > TIME_UP ){
        --timlcd;
    }
    if( timfilter > TIME_UP ){
        --timfilter;
    }
    if( timbtnwait > TIME_UP ){
        --timbtnwait;
    }
}
// DItB^̏ //
void DiFilterInit(void){
	
    CntInit = CNT_INIT_MAX;
	while(CntInit > 0){  //0ɂȂ܂ŃtB^{
		DiFilter();         //DItB^
        __delay_ms(10);     //10msxDItB^
        CntInit--;
		timfilter = TIME_UP;
	}    
}
//--------SWDItB^----------------------------
void DiFilter(void){
    uint8_t i;
    bool    boo = true;

    if( timfilter == TIME_UP ){
        timfilter = TIME_FILTER_MAX;

        DiData.buf[ DiData.wp ] = IO_RB3_GetValue();

        for( i = 1; i < DI_NUM; i++){
            if( DiData.buf[i-1] != DiData.buf[i] ){
                boo = false;
                break;
            }
        }

        if( boo ){ ////rĈvl̗p
             DiData.di = DiData.buf[ 0 ]; 
        }

        if( ++DiData.wp >= DI_NUM){
                DiData.wp = 0;
        }
    }
}
/* LCD̏*/
void LcdInit(void){
    uint8_t i;
    
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, FUNC1_SET ); //WrbgoXE2LINE\
    __delay_us(40);
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, FUNC2_SET ); //gR}h
    __delay_us(40);
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, INT_OSC ); //g
    __delay_us(40);    
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, CONST_SET ); //RgXg1
    __delay_us(40);    
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, PWR_ICON_SET );//RgXg2
    __delay_us(40);   
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, FOLLOWER_SET );//tH[
    __delay_ms(250);
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, FUNC1_SET ); //gR}hIt
    __delay_us(40);
    
    DspClear();
    
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, DISP_ONOFF_SET );
    __delay_us(40);
    
    I2C1_WriteNBytes( SLAVE_ADRS,&initmoji[0][0], sizeof(initmoji[0]));
    
    DspLine2Top();

    for( i = 0; i < sizeof(initmoji[1]); i++ ){
        I2C1_Write1ByteRegister(SLAVE_ADRS,LINE1_ADRS,initmoji[1][i]);
    }        
    __delay_ms(2000);
    DspClear();   
}
/* LCD̃J[\ړ */
void DspLine2Top(void){
    
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, LINE2_TOP );
    __delay_us(40);    
}
/* LCD̕\*/
void DspClear(void){
  
    I2C1_Write1ByteRegister(SLAVE_ADRS, 0x00, CLR_DISP );
    __delay_us(40);
}
/* DispSet function add */
void DispSet(void){
    uint8_t i;
    uint8_t dsp[16];

    sprintf(dsp,"EEP DATA READ:%u", btncntInit);
    for( i = 0; i < sizeof(dsp); i++ ){
        I2C1_Write1ByteRegister(SLAVE_ADRS,LINE1_ADRS,dsp[i]);
    }
  
    DspLine2Top();
    sprintf(dsp,"btncnt:%u       ", btncnt);
    for( i = 0; i < sizeof(dsp); i++ ){
        I2C1_Write1ByteRegister(SLAVE_ADRS,LINE1_ADRS,dsp[i]);
    } 
}
/* EEPf[^ǂݍݏ */
void EepRead(void){
    uint8_t dat;
    uint8_t chk;
    
    dat = DATAEE_ReadByte(EEP_ADRS_M);
    chk = DATAEE_ReadByte(EEP_ADRS_C); 
    
    if(dat == chk){ //d`FbN
        if( dat == 0xFF){
            dat = 0;
        }
        btncntInit = dat;
    }
}
/* End of File */